=== package/CMakeLists.txt ===
set(CPACK_PACKAGE_NAME   "LIEF")
set(CPACK_PACKAGE_VENDOR "Quarkslab")
set(CPACK_PACKAGE_VERSION_MAJOR "${LIEF_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${LIEF_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${LIEF_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION "${LIEF_VERSION_MAJOR}.${LIEF_VERSION_MINOR}.${LIEF_VERSION_PATCH}")

set(CPACK_PACKAGE_CONTACT "contact@lief.re")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "LIEF - Library to Instrument Executable Formats")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_HOMEPAGE_URL "https://lief-project.github.io/")

if (UNIX)
  set(CPACK_SYSTEM_NAME       "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
  set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_SYSTEM_NAME}")
endif()

if(UNIX AND NOT APPLE) # Linux
  set(CPACK_GENERATOR "TGZ")
  set(CPACK_SOURCE_GENERATOR "TGZ")
endif()

if(UNIX AND APPLE) # OSX / iOS
  set(CPACK_GENERATOR "TGZ")
endif()

if(WIN32) # Windows
  set(CPACK_GENERATOR "ZIP")
endif()

include(CPack)
